@-------------------------@
@ Warhawk Main Game Code  @
@ Flash & HeadKaze 2009   @
@-------------------------@
@ v0.3 - FLASH
@ -Have used the same palette for all layers
@ -Moved init code away from main code
@ -added ship and minor control code
@ -Tidy of code
@ -added delay to game start
@ v0.02 - HK
@ - Removed BG_PALETTE(n) because there are no macros for them
@ - Changed to use adrl
@ - Tried to use the -ga and -ps to offset the palettes but didnt work :(
@ V0.01 - Flash
@ - Added 2 backgrounds StarBack and StarFront
@ Duplicated code for the 3 scrollers and init memory for tiles and map data
@----------------------------------------------------------------------------------------------------------@

#include "system.h"
#include "video.h"
#include "background.h"
#include "dma.h"
#include "interrupts.h"
#include "sprite.h"

	.arm
	.align
	.global initSystem
	.global main

initSystem:
	bx lr

main:
	@ Setup the screens and the sprites
	
	bl InitScreens
	bl InitSprites

	@ firstly, lets draw all the screen data ready for play
	@ and display the ship sprite
	
	bl WaitforVblank
	bl drawMapMain
	bl drawMapSub
	bl drawSFMapMain
	bl drawSFMapSub
	bl drawSBMapMain
	bl drawSBMapSub
	bl drawShip
	
	bl WaitforFire
	
@----------------------------@	
@ This is the MAIN game loop @
@----------------------------@
loop:

	bl WaitforVblank

ldr r1,delaySF		@ Delay Starfront for every other update
	subs r1,#1
	bne noscrollSF
		bl scrollSFMain
		bl scrollSFSub
		mov r1,#2
	noscrollSF:
str r1,delaySF	

ldr r1,delaySB		@ Delay Starback for every 4 updates
	subs r1,#1
	bne noscrollSB
		bl scrollSBMain
		bl scrollSBSub
		mov r1,#4
	noscrollSB:
str r1,delaySB

	@ scroll main level data
	bl scrollMain
	bl scrollSub
	
	bl moveShip

@  Kill this for now	
@	bl wobble
@ -------------------

	bl WaitforNoblank


	b loop							@ our main loop


@-------------------- From here on are all the subroutines and data -------------------@




WaitforVblank:
	stmfd sp!, {r0-r6, lr} 
	ldr r0, =REG_VCOUNT
	waitVBlankSUB:									
		ldrh r1, [r0]					@ read REG_VCOUNT into r2
		cmp r1, #193	@ 193 is, of course, the first scanline of vblank
	bne waitVBlankSUB					@ loop if r2 is not equal to (NE condition) 193
	ldmfd sp!, {r0-r6, pc}
	
WaitforNoblank:
	stmfd sp!, {r0-r6, lr} 
	ldr r0, =REG_VCOUNT
	waitVBlankNO:									
		ldrh r1, [r0]					@ read REG_VCOUNT into r2
		cmp r1, #255	
	bne waitVBlankNO					@ loop if r2 is not equal to (NE condition) 193
	ldmfd sp!, {r0-r6, pc}
	.align

delaySF:
	.word 2
delaySB:
	.word 4

vofsMain:
	.word 192
vofsSFMain:
	.word 192
vofsSBMain:
	.word 192
	
vofsSub:
	.word 0
vofsSFSub:
	.word 0
vofsSBSub:
	.word 0

yposMain:
	.word 832
yposSFMain:
	.word 832
yposSBMain:
	.word 832

yposSub:
	.word 832
yposSFSub:
	.word 832
yposSBSub:
	.word 832

xpos:
	.word 0	


scrollMain:
	stmfd sp!, {r0-r6, lr} 

	adrl r2, [vofsMain]
	ldrh r1, [r2]					@ Load r2 with the scroll register
	cmp r1, #0						@ has our scroll register reached zero?
	beq resetScrollMain				@ Then reset our scroller
	cmp r1, #512					@ Has our scroller reached 255 lines?
	beq scrollMapMain				@ If so, time to scroll the map
	subs r1, r1, #1				@ move up a pixel
	ldr r3, =REG_BG1VOFS			@ R2 is the memory adress for the main scroll
	strh r1, [r2]
	strh r1, [r3]					@ write our scroll counter into REG_BG0VOFS main screen	
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
scrollSub:
	stmfd sp!, {r0-r6, lr}
	adrl r2, [vofsSub]
	ldrh r1, [r2]					@ Load r2 with the scroll register
	cmp r1, #0						@ has our scroll register reached zero?
	beq resetScrollSub				@ Then reset our scroller
	cmp r1, #512					@ Has our scroller reached 255 lines?
	beq scrollMapSub				@ If so, time to scroll the map
	subs r1, r1, #1					@ move up a pixel
	ldr r3, =REG_BG1VOFS_SUB		@ R2 is the memory adress for the main scroll
	strh r1, [r2]
	strh r1, [r3]					@ write our scroll counter into REG_BG0VOFS main screen
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
resetScrollMain:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposMain]				@ Ypos is the Y position in the map data
	ldr r1, [r0]					@ r5 now holds our Ypos
	cmp r1, #0						@ are we at ZERO - top of the map?
	beq scrollDone					@ If so, and scroll is 0 also - no need to do anything!
	adrl r0, [vofsMain]
	ldr r1, =REG_BG1VOFS			@ R1 is the memory adress for the sub screen scroll
	ldr r2, =255					@ Now lets restore the scroll register back to 255
	strh r2, [r0]					@ and store in
	strh r2, [r1]					@ and store in
	bl scrollMapMain
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
resetScrollSub:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposSub]				@ Ypos is the Y position in the map data
	ldr r1, [r0]					@ r1 now holds our Ypos
	cmp r1, #0						@ are we at ZERO - top of the map?
	beq scrollDone					@ If so, and scroll is 0 also - no need to do anything!
	adrl r0, [vofsSub]
	ldr r1, =REG_BG1VOFS_SUB		@ R1 is the memory adress for the sub screen scroll
	ldr r2, =255					@ Now lets restore the scroll register back to 255
	strh r2, [r0]					@ and store in
	strh r2, [r1]					@ and store in
	bl scrollMapSub
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return

scrollMapMain:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposMain]				@ grab ypos memory adress
	ldr r1, [r0]					@ r3 = ypos
	sub r1, #64						@ lets go up one block (64 tiles) on the map
	strh r1, [r0]					@ and put the value back for later
	bl drawMapMain
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
scrollMapSub:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposSub]				@ grab ypos memory adress
	ldr r1, [r0]					@ r3 = ypos
	sub r1, #64						@ lets go up one block (64 tiles) on the map
	strh r1, [r0]					@ and put the value back for later
	bl drawMapSub
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
scrollDone:
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	








scrollSFMain:
	stmfd sp!, {r0-r6, lr} 
	adrl r2, [vofsSFMain]
	ldrh r1, [r2]					@ Load r2 with the scroll register
	cmp r1, #0						@ has our scroll register reached zero?
	beq resetScrollSFMain			@ Then reset our scroller
	cmp r1, #512					@ Has our scroller reached 255 lines?
	beq scrollSFMapMain				@ If so, time to scroll the map
	subs r1, r1, #1					@ move up a pixel
	ldr r3, =REG_BG2VOFS			@ R2 is the memory adress for the main scroll
	strh r1, [r2]
	strh r1, [r3]					@ write our scroll counter into REG_BG0VOFS main screen
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return

scrollSFSub:
	stmfd sp!, {r0-r6, lr}
	adrl r2, [vofsSFSub]
	ldrh r1, [r2]					@ Load r2 with the scroll register
	cmp r1, #0						@ has our scroll register reached zero?
	beq resetScrollSFSub			@ Then reset our scroller
	cmp r1, #512					@ Has our scroller reached 255 lines?
	beq scrollSFMapSub				@ If so, time to scroll the map
	subs r1, r1, #1					@ move up a pixel
	ldr r3, =REG_BG2VOFS_SUB		@ R2 is the memory adress for the main scroll
	strh r1, [r2]
	strh r1, [r3]					@ write our scroll counter into REG_BG0VOFS main screen
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return

resetScrollSFMain:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposSFMain]			@ Ypos is the Y position in the map data
	ldr r1, [r0]					@ r5 now holds our Ypos
	cmp r1, #0						@ are we at ZERO - top of the map?
	beq scrollDoneSF				@ If so, and scroll is 0 also - no need to do anything!
	adrl r0, [vofsSFMain]
	ldr r1, =REG_BG2VOFS			@ R1 is the memory adress for the sub screen scroll
	ldr r2, =255					@ Now lets restore the scroll register back to 255
	strh r2, [r0]					@ and store in
	strh r2, [r1]					@ and store in
	bl scrollSFMapMain
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return

resetScrollSFSub:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposSFSub]				@ Ypos is the Y position in the map data
	ldr r1, [r0]					@ r1 now holds our Ypos
	cmp r1, #0						@ are we at ZERO - top of the map?
	beq scrollDoneSF				@ If so, and scroll is 0 also - no need to do anything!
	adrl r0, [vofsSFSub]
	ldr r1, =REG_BG2VOFS_SUB		@ R1 is the memory adress for the sub screen scroll
	ldr r2, =255					@ Now lets restore the scroll register back to 255
	strh r2, [r0]					@ and store in
	strh r2, [r1]					@ and store in
	bl scrollSFMapSub
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return

scrollSFMapMain:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposSFMain]				@ grab ypos memory adress
	ldr r1, [r0]					@ r3 = ypos
	sub r1, #64						@ lets go up one block (64 tiles) on the map
	strh r1, [r0]					@ and put the value back for later
	bl drawSFMapMain
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return

scrollSFMapSub:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposSFSub]				@ grab ypos memory adress
	ldr r1, [r0]					@ r3 = ypos
	sub r1, #64						@ lets go up one block (64 tiles) on the map
	strh r1, [r0]					@ and put the value back for later
	bl drawSFMapSub
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return

scrollDoneSF:
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return



scrollSBMain:
	stmfd sp!, {r0-r6, lr} 

	adrl r2, [vofsSBMain]
	ldrh r1, [r2]					@ Load r2 with the scroll register
	cmp r1, #0						@ has our scroll register reached zero?
	beq resetScrollSBMain				@ Then reset our scroller
	cmp r1, #512					@ Has our scroller reached 255 lines?
	beq scrollSBMapMain				@ If so, time to scroll the map
	subs r1, r1, #1				@ move up a pixel
	ldr r3, =REG_BG3VOFS			@ R2 is the memory adress for the main scroll
	strh r1, [r2]
	strh r1, [r3]					@ write our scroll counter into REG_BG0VOFS main screen	
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
scrollSBSub:
	stmfd sp!, {r0-r6, lr}
	adrl r2, [vofsSBSub]
	ldrh r1, [r2]					@ Load r2 with the scroll register
	cmp r1, #0						@ has our scroll register reached zero?
	beq resetScrollSBSub				@ Then reset our scroller
	cmp r1, #512					@ Has our scroller reached 255 lines?
	beq scrollSBMapSub				@ If so, time to scroll the map
	subs r1, r1, #1					@ move up a pixel
	ldr r3, =REG_BG3VOFS_SUB		@ R2 is the memory adress for the main scroll
	strh r1, [r2]
	strh r1, [r3]					@ write our scroll counter into REG_BG0VOFS main screen
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
resetScrollSBMain:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposSBMain]				@ Ypos is the Y position in the map data
	ldr r1, [r0]					@ r5 now holds our Ypos
	cmp r1, #0						@ are we at ZERO - top of the map?
	beq scrollDoneSB					@ If so, and scroll is 0 also - no need to do anything!
	adrl r0, [vofsSBMain]
	ldr r1, =REG_BG3VOFS			@ R1 is the memory adress for the sub screen scroll
	ldr r2, =255					@ Now lets restore the scroll register back to 255
	strh r2, [r0]					@ and store in
	strh r2, [r1]					@ and store in
	bl scrollSBMapMain
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
resetScrollSBSub:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposSBSub]				@ Ypos is the Y position in the map data
	ldr r1, [r0]					@ r1 now holds our Ypos
	cmp r1, #0						@ are we at ZERO - top of the map?
	beq scrollDoneSB					@ If so, and scroll is 0 also - no need to do anything!
	adrl r0, [vofsSBSub]
	ldr r1, =REG_BG3VOFS_SUB		@ R1 is the memory adress for the sub screen scroll
	ldr r2, =255					@ Now lets restore the scroll register back to 255
	strh r2, [r0]					@ and store in
	strh r2, [r1]					@ and store in
	bl scrollSBMapSub
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return

scrollSBMapMain:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposSBMain]				@ grab ypos memory adress
	ldr r1, [r0]					@ r3 = ypos
	sub r1, #64						@ lets go up one block (64 tiles) on the map
	strh r1, [r0]					@ and put the value back for later
	bl drawSBMapMain
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
	
scrollSBMapSub:
	stmfd sp!, {r0-r6, lr} 
	adrl r0, [yposSBSub]				@ grab ypos memory adress
	ldr r1, [r0]					@ r3 = ypos
	sub r1, #64						@ lets go up one block (64 tiles) on the map
	strh r1, [r0]					@ and put the value back for later
	bl drawSBMapSub
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return
scrollDoneSB:
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return


wobble:
	@ I have not really bothered to comment this as all it does is move the screen left and right
	@ using some sine data, just for effect!

	stmfd sp!, {r0-r6, lr} 
	
	adrl r4,[yposMain]				@ Ypos is the Y position in the map data
	ldr r5,[r4]						@ r5 now holds our Ypos
	ldr r3, =horizdrift			@ r3 is memory location of our sine position counter
	ldrb r1, [r3]					@ r1 is now our offset to our sine data
	cmp r5,#0						@ are we at ZERO - top of the map?
	bne stillwobbles				@ If so, stop wobbling
	
	cmp r1,#32
	beq nomorewobbles
	
	stillwobbles:
	
	adrl r0, [horizontal]			@ r0 is now the memory location of our sine data
	add r0, r1						@ add them together (just as quick as offset)
	ldrb r2, [r0]					@ r2 is now our horizontal scroll register offset
	
	
	add r1, #1						@ move through the sine data
	strb r1, [r3]					@ and put it back - we are using a byte so it will wrap at 255 back to 0
	
	ldr r0, =REG_BG1HOFS_SUB		@ Load our horizontal scroll register for BG0 on the sub screen
	strh r2, [r0]					@ Write our offset value to REG_BG0HOFS_SUB
	ldr r0, =REG_BG1HOFS			@ Load our horizontal scroll register for BG0 on the main screen
	strh r2, [r0]					@ write our offset value to REG_BG2HOFS
	
nomorewobbles:
	ldmfd sp!, {r0-r6, pc} 		@ restore rgisters and return



drawMapMain:
	@ Draw Main Screen
	stmfd sp!, {r0-r6, lr}
	ldr r0, =Level1Map
	ldr r1, =BG_MAP_RAM(4)
	adrl r4, [yposMain]
	ldr r2, [r4]					@ load y2 with ypos (map reference)
	add r0, r2, lsl #6				@ ycoord * 64 added to screenbase
	ldr r2, =8192					@ 64x64x2
	bl dmaCopy
	ldmfd sp!, {r0-r6, pc} 		@ restore registers and return
drawMapSub:
	stmfd sp!, {r0-r6, lr}
	@ Draw Sub screen
	ldr r0, =Level1Map
	ldr r1, =BG_MAP_RAM_SUB(6)
	adrl r4, [yposSub]
	ldr r2, [r4]					@ load y2 with ypos (map reference)
	add r0, r2, lsl #6				@ ycoord * 64 added to screenbase
	ldr r2, =8192					@ 64x64x2
	bl dmaCopy
	ldmfd sp!, {r0-r6, pc} 		@ restore registers and return

drawSFMapMain:
	@ Draw Main Screen
	stmfd sp!, {r0-r6, lr}
	ldr r0, =StarFrontMap
	ldr r1, =BG_MAP_RAM(8)
	adrl r4, [yposSFMain]
	ldr r2, [r4]					@ load y2 with ypos (map reference)
	add r0, r2, lsl #6				@ ycoord * 64 added to screenbase
	ldr r2, =8192					@ 64x64x2
	bl dmaCopy
	ldmfd sp!, {r0-r6, pc} 		@ restore registers and return
drawSFMapSub:
	stmfd sp!, {r0-r6, lr}
	@ Draw Sub screen
	ldr r0, =StarFrontMap
	ldr r1, =BG_MAP_RAM_SUB(10)
	adrl r4, [yposSFSub]
	ldr r2, [r4]					@ load y2 with ypos (map reference)
	add r0, r2, lsl #6				@ ycoord * 64 added to screenbase
	ldr r2, =8192					@ 64x64x2
	bl dmaCopy
	ldmfd sp!, {r0-r6, pc} 		@ restore registers and return

drawSBMapMain:
	@ Draw Main Screen
	stmfd sp!, {r0-r6, lr}
	ldr r0, =StarBackMap
	ldr r1, =BG_MAP_RAM(12)
	adrl r4, [yposSBMain]
	ldr r2, [r4]					@ load y2 with ypos (map reference)
	add r0, r2, lsl #6				@ ycoord * 64 added to screenbase
	ldr r2, =8192					@ 64x64x2
	bl dmaCopy
	ldmfd sp!, {r0-r6, pc} 		@ restore registers and return
drawSBMapSub:
	stmfd sp!, {r0-r6, lr}
	@ Draw Sub screen
	ldr r0, =StarBackMap
	ldr r1, =BG_MAP_RAM_SUB(14)
	adrl r4, [yposSBSub]
	ldr r2, [r4]					@ load y2 with ypos (map reference)
	add r0, r2, lsl #6				@ ycoord * 64 added to screenbase
	ldr r2, =8192					@ 64x64x2
	bl dmaCopy
	ldmfd sp!, {r0-r6, pc} 		@ restore registers and return



InitScreens:
	stmfd sp!, {lr}
	ldr r0, =REG_POWERCNT
	ldr r1, =POWER_ALL_2D			@ All power on
	str r1, [r0]
 
	mov r0, #REG_DISPCNT			@ Main screen to Mode 0 with BG2 active
	ldr r1, =(MODE_0_2D | DISPLAY_SPR_ACTIVE | DISPLAY_SPR_1D_LAYOUT | DISPLAY_BG0_ACTIVE | DISPLAY_BG1_ACTIVE | DISPLAY_BG2_ACTIVE | DISPLAY_BG3_ACTIVE)
	str r1, [r0]
	
	ldr r0, =REG_DISPCNT_SUB		@ Sub screen to Mode 0 with BG0 active
	ldr r1, =(MODE_0_2D | DISPLAY_SPR_ACTIVE | DISPLAY_SPR_1D_LAYOUT | DISPLAY_BG0_ACTIVE | DISPLAY_BG1_ACTIVE | DISPLAY_BG2_ACTIVE | DISPLAY_BG3_ACTIVE)
	str r1, [r0]
 
	ldr r0, =VRAM_A_CR				@ Set VRAM A to be main bg address 0x06000000
	ldr r1, =(VRAM_ENABLE | VRAM_A_MAIN_BG_0x06000000)
	strb r1, [r0]

	ldr r0, =VRAM_B_CR				@ Use this for sprite data
	ldr r1, =(VRAM_ENABLE | VRAM_A_MAIN_SPRITE)
	strb r1, [r0]
	
	ldr r0, =VRAM_C_CR				@ Set VRAM C to be sub bg address 0x06200000
	ldr r1, =(VRAM_ENABLE | VRAM_C_SUB_BG_0x06200000)
	strb r1, [r0]
	
	ldr r0, =VRAM_D_CR				@ Use this for sprite data
	ldr r1, =(VRAM_ENABLE | VRAM_D_SUB_SPRITE)
	strb r1, [r0]

	ldr r0, =REG_BG0CNT				@ Set main screen BG0 format to be 64x64 tiles at base address
	ldr r1, =(BG_COLOR_16 | BG_32x32 | BG_MAP_BASE(0) | BG_TILE_BASE(6) | BG_PRIORITY(0))
	strh r1, [r0]
	ldr r0, =REG_BG0CNT_SUB			@ Set sub screen BG0 format to be 64x64 tiles at base address
	ldr r1, =(BG_COLOR_16 | BG_32x32 | BG_MAP_BASE(2) | BG_TILE_BASE(7) | BG_PRIORITY(0))
	strh r1, [r0]
	
	ldr r0, =REG_BG1CNT				@ Set main screen BG0 format to be 64x64 tiles at base address
	ldr r1, =(BG_COLOR_16 | BG_64x64 | BG_MAP_BASE(4) | BG_TILE_BASE(5) | BG_PRIORITY(1))
	strh r1, [r0]
	ldr r0, =REG_BG1CNT_SUB			@ Set sub screen BG0 format to be 64x64 tiles at base address
	ldr r1, =(BG_COLOR_16 | BG_64x64 | BG_MAP_BASE(6) | BG_TILE_BASE(5) | BG_PRIORITY(1))
	strh r1, [r0]
	
	ldr r0, =REG_BG2CNT				@ Set main screen BG0 format to be 64x64 tiles at base address
	ldr r1, =(BG_COLOR_16 | BG_64x64 | BG_MAP_BASE(8) | BG_TILE_BASE(8) | BG_PRIORITY(2))
	strh r1, [r0]
	ldr r0, =REG_BG2CNT_SUB			@ Set sub screen BG0 format to be 64x64 tiles at base address
	ldr r1, =(BG_COLOR_16 | BG_64x64 | BG_MAP_BASE(10) | BG_TILE_BASE(8) | BG_PRIORITY(2))
	strh r1, [r0]

	ldr r0, =REG_BG3CNT				@ Set main screen BG3 format to be 64x64 tiles at base address
	ldr r1, =(BG_COLOR_256 | BG_64x64 | BG_MAP_BASE(12) | BG_TILE_BASE(3) | BG_PRIORITY(3))
	strh r1, [r0]
	ldr r0, =REG_BG3CNT_SUB			@ Set sub screen BG3 format to be 64x64 tiles at base address
	ldr r1, =(BG_COLOR_256 | BG_64x64 | BG_MAP_BASE(14) | BG_TILE_BASE(3) | BG_PRIORITY(3))
	strh r1, [r0]
	
	@ Load the palette into the palette subscreen area and main

	ldr r0, =StarBackPal
	ldr r1, =BG_PALETTE(0)
	ldr r2, =512
	bl dmaCopy
	ldr r1, =BG_PALETTE_SUB(0)
	bl dmaCopy
	
	@ Write the tile data to VRAM Level BG1

	ldr r0, =Level1Tiles
	ldr r1, =BG_TILE_RAM(5)
	ldr r2, =11200
	bl dmaCopy
	ldr r1, =BG_TILE_RAM_SUB(5)
	bl dmaCopy
	
	@ Write the tile data to VRAM FrontStar BG2

	ldr r0, =StarFrontTiles
	ldr r1, =BG_TILE_RAM(8)
	ldr r2, =4096
	bl dmaCopy
	ldr r1, =BG_TILE_RAM_SUB(8)
	bl dmaCopy

	@ Write the tile data to VRAM BackStar BG3

	ldr r0, =StarBackTiles
	ldr r1, =BG_TILE_RAM(3)
	ldr r2, =27456
	bl dmaCopy
	ldr r1, =BG_TILE_RAM_SUB(3)
	bl dmaCopy

	@ Our horizontal centre routine
	
	ldr r0, =REG_BG1HOFS			@ Load our horizontal scroll register for BG1 on the main screen
	ldr r1, =REG_BG1HOFS_SUB		@ Load our horizontal scroll register for BG1 on the sub screen
	ldr r2, =REG_BG2HOFS			@ Load our horizontal scroll register for BG2 on the main screen
	ldr r3, =REG_BG2HOFS_SUB		@ Load our horizontal scroll register for BG2 on the sub screen
	ldr r4, =REG_BG3HOFS			@ Load our horizontal scroll register for BG3 on the main screen
	ldr r5, =REG_BG3HOFS_SUB		@ Load our horizontal scroll register for BG3 on the sub screen
	mov r6, #32						@ Offset the horizontal scroll register by 32 pixels to centre the map
	strh r6, [r0]					@ Write our offset value to REG_BG1HOFS
	strh r6, [r1]					@ Write our offset value to REG_BG1HOFS_SUB
	strh r6, [r2]					@ Write our offset value to REG_BG2HOFS
	strh r6, [r3]					@ Write our offset value to REG_BG2HOFS_SUB
	strh r6, [r4]					@ Write our offset value to REG_BG3HOFS
	strh r6, [r5]					@ Write our offset value to REG_BG3HOFS_SUB

		
	@ Our vertical scrolling routine

	ldr r0, =REG_BG1VOFS			@ Load our vertical scroll register for BG1 on the main screen
	adrl r2, [vofsMain]				@ Set our scroll counter to start main screen
	ldrh r2, [r2]
	strh r2, [r0]					@ Load the value into the scroll register

	ldr r0, =REG_BG1VOFS_SUB		@ Load our vertical scroll register for BG1 on the sub screen
	adrl r2, [vofsSub]				@ Set our scroll counter to start sub screen
	ldrh r2, [r2]
	strh r2, [r0]					@ Load the value into the scroll register
	
	ldr r0, =REG_BG2VOFS			@ Load our vertical scroll register for BG2 on the main screen
	adrl r2, [vofsSFMain]				@ Set our scroll counter to start main screen
	ldrh r2, [r2]
	strh r2, [r0]					@ Load the value into the scroll register

	ldr r0, =REG_BG2VOFS_SUB		@ Load our vertical scroll register for BG2 on the sub screen
	adrl r2, [vofsSFSub]				@ Set our scroll counter to start sub screen
	ldrh r2, [r2]
	strh r2, [r0]					@ Load the value into the scroll register

	ldr r0, =REG_BG3VOFS			@ Load our vertical scroll register for BG3 on the main screen
	adrl r2, [vofsSBMain]				@ Set our scroll counter to start main screen
	ldrh r2, [r2]
	strh r2, [r0]					@ Load the value into the scroll register

	ldr r0, =REG_BG3VOFS_SUB		@ Load our vertical scroll register for BG3 on the sub screen
	adrl r2, [vofsSBSub]				@ Set our scroll counter to start sub screen
	ldrh r2, [r2]
	strh r2, [r0]	
	
	ldmfd sp!, {pc} 

InitSprites:
	stmfd sp!, {lr}

	@ Load the palette into the palette subscreen area and main

	ldr r0, =SpritesPal
	ldr r1, =SPRITE_PALETTE
	ldr r2, =512
	bl dmaCopy
	ldr r1, =SPRITE_PALETTE_SUB
	bl dmaCopy

	@ Write the tile data to VRAM

	ldr r0, =SpritesTiles
	ldr r1, =SPRITE_GFX
	ldr r2, =1024
	bl dmaCopy
	ldr r1, =SPRITE_GFX_SUB
	bl dmaCopy
	
	@ Clear the OAM (disable all 128 sprites for both screens)

	ldr r0, =ATTR0_DISABLED			@ Set OBJ_ATTRIBUTE0 to ATTR0_DISABLED
	ldr r1, =OAM
	ldr r2, =1024					@ 3 x 16bit attributes + 16 bit filler = 8 bytes x 128 entries in OAM
	bl dmaFillWords
	ldr r1, =OAM_SUB
	bl dmaFillWords

	ldmfd sp!, {pc} 
	
WaitforFire:
	@ Messy bit just to wait for button to start
	@ This is a delay that can be skipped by FIRE
	@ Not great, but serves its purpose for now
	@ this will need to update music at later stage also
	
	stmfd sp!, {lr}
	mov r4,#200
	buttpause:
	bl WaitforVblank

	ldr r1,delaySF		@ Delay Starfront for every other update
	subs r1,#1
	bne noscrollSF1
		bl scrollSFMain
		bl scrollSFSub
		mov r1,#2
	noscrollSF1:
	str r1,delaySF	
	ldr r1,delaySB		@ Delay Starback for every 4 updates
	subs r1,#1
	bne noscrollSB1
		bl scrollSBMain
		bl scrollSBSub
		mov r1,#4
	noscrollSB1:
	str r1,delaySB

	bl WaitforNoblank
	
	ldr r1,=REG_KEYINPUT
	ldr r2,[r1]
	mov r3,#1
	and r2,r3
	cmp r2,#0
	beq butta
	subs r4,#1
	bne buttpause
	butta:	
	ldmfd sp!, {pc} 
	

drawShip:
	stmfd sp!, {lr}
	
	ldr r0, =OBJ_ATTRIBUTE0(0)
	ldr r1, =(ATTR0_COLOR_16 | ATTR0_SQUARE)
	strh r1, [r0]
	ldr r0, =OBJ_ATTRIBUTE1(0)
	ldr r1, =(ATTR1_SIZE_32)
	strh r1, [r0]
	ldr r0, =OBJ_ATTRIBUTE2(0)
	ldr r1, =(0 | ATTR2_PRIORITY(0) | ATTR2_PALETTE(0))
	strh r1, [r0]
	
	ldr r5,=shipY
	ldr r6,=shipX
	ldr r0, =OBJ_ATTRIBUTE0(0) @ Plot Y Coord
	
	ldr r1,[r5]
	strb r1, [r0]
	ldr r0, =OBJ_ATTRIBUTE1(0) @ Plot x Coord
	ldr r1,[r6]
	strb r1, [r0]
	
	ldmfd sp!, {pc}

moveShip:
	stmfd sp!, {r0-r8,lr}
	ldr r5,=shipY
	ldr r6,=shipX
	ldr r1,=REG_KEYINPUT		@ Read the keys!
	ldr r2,[r1]					@ R2 is the input (except X and Y handled by ARM7)
	mov r3,#64					@ UP (and with value to isolate direction)
	and r2,r3
	cmp r2,#0
	bne dircheck1
	@ Up code
		ldrb r8,[r5]
		subs r8,#1
		bpl dircheck0pass
		mov r8,#0
		dircheck0pass:
		strb r8,[r5]
		b dircheck2
	dircheck1:
	ldr r2,[r1]					@ R2 is the input (except X and Y handled by ARM7)
	mov r3,#128					@ UP (and with value to isolate direction)
	and r2,r3
	cmp r2,#0
	bne dircheck2
	@ Down code
		ldrb r8,[r5]
		adds r8,#1
		cmp r8,#160
		bmi dircheck1pass
		mov r8,#160
		dircheck1pass:
		strb r8,[r5]
	dircheck2:
	ldr r2,[r1]					@ R2 is the input (except X and Y handled by ARM7)
	mov r3,#32					@ UP (and with value to isolate direction)
	and r2,r3
	cmp r2,#0
	bne dircheck3
	@ Left code
		ldrb r8,[r6]
		subs r8,#1
		bpl dircheck2pass
		mov r8,#0
		dircheck2pass:
		strb r8,[r6]
		b dircheck4
	dircheck3:
	ldr r2,[r1]					@ R2 is the input (except X and Y handled by ARM7)
	mov r3,#16					@ UP (and with value to isolate direction)
	and r2,r3
	cmp r2,#0
	bne dircheck4
	@ Right code
		ldrb r8,[r6]
		adds r8,#1
		cmp r8,#224
		bmi dircheck3pass
		mov r8,#224
		dircheck3pass:
		strb r8,[r6]
	dircheck4:
	@ Update the Ship with the valid position
	ldr r0, =OBJ_ATTRIBUTE0(0) @ Plot Y Coord
	ldr r1,shipY
	strb r1, [r0]
	ldr r0, =OBJ_ATTRIBUTE1(0) @ Plot x Coord
	ldr r1,shipX
	strb r1, [r0]
	
	ldmfd sp!, {r0-r8,pc}
	
.align
		
delaysc:
	.byte 1

horizdrift:
	.byte 0
shipX:
	.byte 128-16
shipY:
	.byte 192-32
	
horizontal:
.byte  33 , 34 , 34 , 35 , 36 , 37 , 37 , 38 
.byte  39 , 40 , 40 , 41 , 42 , 43 , 43 , 44 
.byte  45 , 45 , 46 , 47 , 48 , 48 , 49 , 50 
.byte  50 , 51 , 51 , 52 , 53 , 53 , 54 , 54 
.byte  55 , 55 , 56 , 56 , 57 , 57 , 58 , 58 
.byte  59 , 59 , 59 , 60 , 60 , 60 , 61 , 61 
.byte  61 , 62 , 62 , 62 , 62 , 63 , 63 , 63 
.byte  63 , 63 , 63 , 63 , 63 , 63 , 63 , 63 
.byte  63 , 63 , 63 , 63 , 63 , 63 , 63 , 63 
.byte  63 , 63 , 62 , 62 , 62 , 62 , 61 , 61 
.byte  61 , 60 , 60 , 60 , 59 , 59 , 59 , 58 
.byte  58 , 57 , 57 , 56 , 56 , 55 , 55 , 54 
.byte  54 , 53 , 53 , 52 , 51 , 51 , 50 , 50 
.byte  49 , 48 , 48 , 47 , 46 , 45 , 45 , 44 
.byte  43 , 43 , 42 , 41 , 40 , 40 , 39 , 38 
.byte  37 , 37 , 36 , 35 , 34 , 34 , 33 , 32 
.byte  31 , 30 , 30 , 29 , 28 , 27 , 27 , 26 
.byte  25 , 24 , 24 , 23 , 22 , 21 , 21 , 20 
.byte  19 , 19 , 18 , 17 , 16 , 16 , 15 , 14 
.byte  14 , 13 , 13 , 12 , 11 , 11 , 10 , 10 
.byte  9 , 9 , 8 , 8 , 7 , 7 , 6 , 6 
.byte  5 , 5 , 5 , 4 , 4 , 4 , 3 , 3 
.byte  3 , 2 , 2 , 2 , 2 , 1 , 1 , 1 
.byte  1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 
.byte  1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 
.byte  1 , 1 , 2 , 2 , 2 , 2 , 3 , 3 
.byte  3 , 4 , 4 , 4 , 5 , 5 , 5 , 6 
.byte  6 , 7 , 7 , 8 , 8 , 9 , 9 , 10 
.byte  10 , 11 , 11 , 12 , 13 , 13 , 14 , 14 
.byte  15 , 16 , 16 , 17 , 18 , 19 , 19 , 20 
.byte  21 , 21 , 22 , 23 , 24 , 24 , 25 , 26 
.byte  27 , 27 , 28 , 29 , 30 , 30 , 31 , 32



